package conferenciaJPAAlunos;

import java.util.*;
import javax.persistence.*;

@Entity
//@Table(name="PESSOA")
@DiscriminatorValue("2")
public class Avaliador extends Pessoa{

    private String login;
    private String senha;
    private String email;
    private String origem;

    private Set<Topico> topicos;
    private Set<Revisao> revisoes;

    public Avaliador (){
       	this.revisoes = new HashSet<Revisao>();
    	this.topicos = new HashSet<Topico>();  
    }    
  
	public void setEmail(String email) {
		this.email = email;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public void setOrigem(String origem) {
		this.origem = origem;
	}

	public String getLogin() {
		return login;
	}

	public void setSenha(String senha) {
		this.senha = senha;
	}

	public String getOrigem() {
		return origem;
	}

	public String getSenha() {
		return senha;
	}

	public String getEmail() {
		return email;
	}

	@ManyToMany(targetEntity=Topico.class)
	@JoinTable(name="TOPICO_AVALIADOR",joinColumns=@JoinColumn(name="NOME_AVALIADOR",referencedColumnName="NOME"),inverseJoinColumns=@JoinColumn(name="NOME_TOPICO",referencedColumnName="NOME"))     
	public Set<Topico> getTopicos() {
		return topicos;
	}

	@OneToMany(targetEntity=Revisao.class,cascade=CascadeType.ALL, mappedBy="avaliador")
	public Set<Revisao> getRevisoes() {
		return revisoes;
	}

	public void setRevisoes(Set<Revisao> list) {
		revisoes = list;
	}

	public void setTopicos(Set<Topico> list) {
		topicos = list;
	}

    public void associaTopico(Topico topico){
    	if (!this.topicos.contains(topico))
	    	this.topicos.add(topico);
    }

    public void associaRevisao(Revisao revisao){
		if (!this.revisoes.contains(revisao))
	    	this.revisoes.add(revisao);
    }
    
    public Set<Artigo> retornaArtigosAvaliados(){
    	Set<Artigo> artigos = new HashSet<Artigo>();
		Iterator<Revisao> iter = this.revisoes.iterator();
		while (iter.hasNext()){
    		Revisao revisao = (Revisao)iter.next();
    		artigos.add(revisao.getArtigo());
    	}
    	return artigos;
    }
    
   public String toString (){
		return this.getNome() + " " + this.email;
	}
}
