package conferenciaJPAAlunos;

import javax.persistence.*;

@Entity
@Table(name="REVISAO")
public class Revisao {

	private double clareza;
    private double relevancia;
    private double corretude;
    private double notaFinal;
    private String comentariosComite;
    private String comentariosAutor;
	private ChaveRevisao chave = new ChaveRevisao();  //criado por exigencia da JPA
    private Artigo artigo;
    private Avaliador avaliador;

    public Revisao (){
    }

	@ManyToOne
	@JoinColumn(name="NOME_ARTIGO",insertable=false,updatable=false)
	public Artigo getArtigo (){
    	return this.artigo;
    }

	@ManyToOne
	@JoinColumn(name="NOME_AVALIADOR",insertable=false,updatable=false)
   public Avaliador getAvaliador (){
    	return this.avaliador;
    }

	public void setChave(ChaveRevisao chave) {
		this.chave = chave;
	}

    @EmbeddedId
	public ChaveRevisao getChave() {
		return chave;
	}

	public double getClareza() {
		return clareza;
	}

	@Column(name="COMENT_AUTOR")
	public String getComentariosAutor() {
		return comentariosAutor;
	}

	@Column(name="COMENT_COMITE")
	public String getComentariosComite() {
		return comentariosComite;
	}

	public double getCorretude() {
		return corretude;
	}

	@Column(name="NOTA_FINAL")
	public double getNotaFinal() {
		return notaFinal;
	}

	public double getRelevancia() {
		return relevancia;
	}

	public void setClareza(double clareza) {
		this.clareza = clareza;
	}

	public void setComentariosAutor(String comentariosAutor) {
		this.comentariosAutor = comentariosAutor;
	}

	public void setComentariosComite(String comentariosComite) {
		this.comentariosComite = comentariosComite;
	}

	public void setCorretude(double corretude) {
		this.corretude = corretude;
	}

	public void setNotaFinal(double notaFinal) {
		this.notaFinal = notaFinal;
	}

	public void setRelevancia(double relevancia) {
		this.relevancia = relevancia;
	}

	public void setArtigo(Artigo artigo) {
		this.artigo = artigo;
		this.chave.setNomeArtigo(artigo.getNome());
	}

	public void setAvaliador(Avaliador avaliador) {
		this.avaliador = avaliador;
		this.chave.setNomeAvaliador(avaliador.getNome());
	}

}
